# all files / ol/ color.js

91.67% Statements 77/84
88.24% Branches 30/34
100% Functions 8/8
91.67% Lines 77/84

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    2021×

    1×
    1×

    1×

    1×

    1×
    80×
    71×

    9×

    1×
    5895×
    23×

    5872×

    1×
    1×
    1×
    1×
    1×
    1×
    1×

    1×

    1×

    1×

    1×

    1×

    25×
    25×
    3×

    22×

    22×
    22×
    22×

    25×

    1×
    22×

    22×
    1×

    22×
    5×
    5×
    5×
    5×
    5×
    5×
    5×
    1×
    1×
    1×

    5×
    5×
    17×
    12×
    12×
    5×
    5×
    5×
    5×

    22×

    1×
    19×
    19×
    19×
    19×
    19×
    19×

    1×
    5875×
    5875×
    1×

    5875×
    5875×
    1×

    5875×
    5875×
    1×

    5875×
    5875×

     goog.provide('ol.color');

    goog.require('ol.asserts');
    goog.require('ol.math');

    /**
     * This RegExp matches # followed by 3 or 6 hex digits.
     * @const
     * @type {RegExp}
     * @private
     */
    ol.color.HEX_COLOR_RE_ = /^#(?:[0-9a-f]{3}){1,2}$/i;

    /**
     * Regular expression for matching potential named color style strings.
     * @const
     * @type {RegExp}
     * @private
     */
    ol.color.NAMED_COLOR_RE_ = /^([a-z]*)$/i;

    /**
     * Return the color as an array. This function maintains a cache of calculated
     * arrays which means the result should not be modified.
     * @param {ol.Color|string} color Color.
     * @return {ol.Color} Color.
     * @api
     */
    ol.color.asArray = function(color) {
      if (Array.isArray(color)) {
        return color;
      } else {
        return ol.color.fromString(/** @type {string} */ (color));
      }
    };

    /**
     * Return the color as an rgba string.
     * @param {ol.Color|string} color Color.
     * @return {string} Rgba string.
     * @api
     */
    ol.color.asString = function(color) {
      if (typeof color === 'string') {
        return color;
      } else {
        return ol.color.toString(color);
      }
    };

    /**
     * Return named color as an rgba string.
     * @param {string} color Named color.
     * @return {string} Rgb string.
     */
    ol.color.fromNamed = function(color) {
      var el = document.createElement('div');
      el.style.color = color;
      document.body.appendChild(el);
      var rgb = getComputedStyle(el).color;
      document.body.removeChild(el);
      return rgb;
    };

    /**
     * @param {string} s String.
     * @return {ol.Color} Color.
     */
    ol.color.fromString = (
      function() {

        // We maintain a small cache of parsed strings.  To provide cheap LRU-like
        // semantics, whenever the cache grows too large we simply delete an
        // arbitrary 25% of the entries.

        /**
         * @const
         * @type {number}
         */
        var MAX_CACHE_SIZE = 1024;

        /**
         * @type {Object.<string, ol.Color>}
         */
        var cache = {};

        /**
         * @type {number}
         */
        var cacheSize = 0;

        return (
          /**
           * @param {string} s String.
           * @return {ol.Color} Color.
           */
          function(s) {
            var color;
            if (cache.hasOwnProperty(s)) {
              color = cache[s];
            } else {
              Iif (cacheSize >= MAX_CACHE_SIZE) {
                var i = 0;
                var key;
                for (key in cache) {
                  if ((i++ & 3) === 0) {
                    delete cache[key];
                    --cacheSize;
                  }
                }
              }
              color = ol.color.fromStringInternal_(s);
              cache[s] = color;
              ++cacheSize;
            }
            return color;
          });

      })();

    /**
     * @param {string} s String.
     * @private
     * @return {ol.Color} Color.
     */
    ol.color.fromStringInternal_ = function(s) {
      var r, g, b, a, color, parts;

      if (ol.color.NAMED_COLOR_RE_.exec(s)) {
        s = ol.color.fromNamed(s);
      }

      if (ol.color.HEX_COLOR_RE_.exec(s)) { // hex
        var n = s.length - 1; // number of hex digits
        ol.asserts.assert(n == 3 || n == 6, 54); // Hex color should have 3 or 6 digits
        var d = n == 3 ? 1 : 2; // number of digits per channel
        r = parseInt(s.substr(1 + 0 * d, d), 16);
        g = parseInt(s.substr(1 + 1 * d, d), 16);
        b = parseInt(s.substr(1 + 2 * d, d), 16);
        if (d == 1) {
          r = (r << 4) + r;
          g = (g << 4) + g;
          b = (b << 4) + b;
        }
        a = 1;
        color = [r, g, b, a];
      } else if (s.indexOf('rgba(') == 0) { // rgba()
        parts = s.slice(5, -1).split(',').map(Number);
        color = ol.color.normalize(parts);
      } else Eif (s.indexOf('rgb(') == 0) { // rgb()
        parts = s.slice(4, -1).split(',').map(Number);
        parts.push(1);
        color = ol.color.normalize(parts);
      } else {
        ol.asserts.assert(false, 14); // Invalid color
      }
      return /** @type {ol.Color} */ (color);
    };

    /**
     * @param {ol.Color} color Color.
     * @param {ol.Color=} opt_color Color.
     * @return {ol.Color} Clamped color.
     */
    ol.color.normalize = function(color, opt_color) {
      var result = opt_color || [];
      result[0] = ol.math.clamp((color[0] + 0.5) | 0, 0, 255);
      result[1] = ol.math.clamp((color[1] + 0.5) | 0, 0, 255);
      result[2] = ol.math.clamp((color[2] + 0.5) | 0, 0, 255);
      result[3] = ol.math.clamp(color[3], 0, 1);
      return result;
    };

    /**
     * @param {ol.Color} color Color.
     * @return {string} String.
     */
    ol.color.toString = function(color) {
      var r = color[0];
      if (r != (r | 0)) {
        r = (r + 0.5) | 0;
      }
      var g = color[1];
      if (g != (g | 0)) {
        g = (g + 0.5) | 0;
      }
      var b = color[2];
      if (b != (b | 0)) {
        b = (b + 0.5) | 0;
      }
      var a = color[3] === undefined ? 1 : color[3];
      return 'rgba(' + r + ',' + g + ',' + b + ',' + a + ')';
    };